 ////////////////////////////////////////////////////////////////////////////////////
////////   Single_entry holder and all_entries holder classes  /////////////////////

function _Clone(){
  var NewObj = new Object();
  for (var oP in this) NewObj[oP]=this[oP];
  return NewObj;
}

function _StoreInput(inp){
	lst = new Object();
	inobj = new Object();
	inobj.name = String(inp.name);
	inobj.value = String(inp.value);
	if (inp.label) {inobj.label=inp.label} else {inobj.label=""};
	if (inp.grouptitle) {inobj.grouptitle=inp.grouptitle} else {inobj.grouptitle=""};
	inobj.priority = String(inp.priority);
	ItemName = inp.name;
	//ItemName = String(inp.priority);
	
	if (this.Inputs!=null){
		if (this.Inputs[ItemName]){
			if (!this.Inputs[ItemName].list) {
			  this.Inputs[ItemName].list = new Object();
			  this.Inputs[ItemName].list[this.Inputs[ItemName].def.priority] = this.Inputs[ItemName].def;
			}
			this.Inputs[ItemName].list[inp.priority] = inobj;
		}else{
			this.Inputs[ItemName] = new Object();
			this.Inputs[ItemName] = inobj;
			this.Inputs[ItemName].def = new Object();
			this.Inputs[ItemName].def = inobj;
			//this.Inputs[ItemName].list = new Object();
			//this.Inputs[ItemName].list[inp.priority] = inobj;
		}
	}else{
		this.Inputs = new Object();
		this.Inputs[ItemName] = new Object();
    this.Inputs[ItemName] = inobj;
		this.Inputs[ItemName].def = new Object();
		this.Inputs[ItemName].def = inobj;
	}
}

function ProtoEntry() {
  this.eId =  "";
  this.Title = "";
  this.Action = "";
  this.Method = "";
  this.Desc =  "";
  //this.Inputs = new Object;
  this.Context = true;
  this.blocked = false;
  this.filepath = "";
  this.iconpath = "";
  this.qcharset="UTF-8";
  this.showif = "";
  this.sitarget = "[:selection]";
  this.si_compiled = new Object;
  this.lastmatch = [];
  this._Clone = _Clone;
  this._StoreInput = _StoreInput;

	//watchers
	this.watch("Method",
	  function(id,oldval,newval){
	    if (!((newval != "POST") || (newval != "GET"))) newval = "GET";
	    return newval;
	  }
	)
}
ProtoEntry.prototype = ProtoEntry;

//Entries holder:
function _AddEntryObj(EntryObj, eId){
	eId = String(EntryObj.filepath).replace(/[\\\/\.:]/ig, "");
    EntryObj.eId = eId;
    this[eId] = EntryObj._Clone();
    this._Empty = false;
    return eId;
}

function _UpdateEntry(EntryObj){
  for (each in EntryObj){
    if (each != "Inputs") this[each]=EntryObj[each]}
}
function _Exist(KeyName){
  var exst=false;
  if (this[KeyName]) exst=true; 
  return exst;
}
function _Item(KeyName){
	return this[KeyName];
}
function _Rm(Key){
    delete this[Key];
}
function _Items(){
try{
  var items = [];
  for (item in this) if ((item.substr(0,1) != "_") && (item.substr(0,9) != "prototype")) items[items.length] = this[item];
  items.sort(this._Cmp);
  return items;
}catch(er){cqerr(er, "_Items method")}
}
function _Cmp(a, b){
  if (a.Title.toLowerCase() > b.Title.toLowerCase()){return 1;}
  else if (a.Title.toLowerCase() < b.Title.toLowerCase()) {return -1;}
  else {return 0;}
}
function _Clear(){
  for (item in this) if (item.substr(0,1) != "_")	delete this[item];
  this._Empty = true;
}

function _ProtoHash(){
	this._Empty = true;
	this._AddEntryObj = _AddEntryObj;
	this._UpdateEntry = _UpdateEntry;
	this._Exist = _Exist;
	this._Item = _Item;
	this._Items = _Items;
	this._Rm = _Rm;
	this._Cmp = _Cmp;
	this._Clear = _Clear;
	this._Clone = _Clone;
}
_ProtoHash.prototype = _ProtoHash;
 /////// END classes ////////
////////////////////////////


 ////////////////////////////
//////// Globals ///////////

//Active Entries holder
var EntryHash = new _ProtoHash();

var QueryHash = new Object();
var curDirState = new Object();
var lastDirState = new Object();
var cqrShowAlternatives = false;
var cqrcancel = false;


var cqrParamsRE = new RegExp('\\w+\\s*?=\\s*?".*?"',"ig");
var cqrSIRe = new RegExp("\\[:(\\w+)(:(\\d*))?\\]", "ig");

if (navigator.userAgent.search(/Thunderbird/gi) != -1){
    var cqrMailFlag = true;
} else {
    var cqrMailFlag = false;
}

var cqr_platform = new String(navigator.platform);
if(cqr_platform.search(/^Win/)) {
    if(cqr_platform.search(/^Mac/)) {
        var cqrdelim = "/";
    } else {
        var cqrdelim = ":";
    }
} else {
    var cqrdelim = "\\";
}
var cqrMess = srGetStrBundle("chrome://conquery/locale/conquery.properties");

/// Prefs globals ///
var cqrPrefs = Components.classes["@mozilla.org/preferences-service;1"].
  getService(Components.interfaces.nsIPrefService).getBranch("conquery.");
var cqrPlugsDir = "";
var cqrUseHotMenu = false;
var cqrHTTPIcon = true;
var cqrOpenRes = "";
var cqrHideFromTools = false;
prfs_LoadMain();

function cqerr(r, msg){
alert (cqrMess.GetStringFromName("cqr.err.failed")+msg+"\n"+r);
}

function plg_QuickLoadAll(){
  EntryHash._Clear();
  lastDirState = rdir(cqrPlugsDir);
  for (each in lastDirState) {EntryHash._AddEntryObj(plg_quickread(each), "")}
}

function plg_quickread(filepath){
  var retItem = new ProtoEntry();
	filedata = cqReadFile(filepath);
	filedata = filedata.replace(/#.*/ig,"");
	filedata = filedata.replace(/[\n\r\f\t]/ig,"  ");
	SearchTagData = filedata.match(/<search.+?<\/search>/gi);
	mcSearch = plg_GetTags("search", SearchTagData);
	//mcSearch = plg_GetTags("search", filedata);
	if (mcSearch[0]){
		retItem.Title = mcSearch[0].name || cqrMess.GetStringFromName('cqr.err.parse');
		retItem.Action = mcSearch[0].action || "http://conquery.mozdev.org/pluginsdocs.html";
		retItem.Desc = mcSearch[0].description || "";
		//XXX: Leo's malformed plugins special patch:
		    p_plgname = filepath.split(cqrdelim);
		    if (p_plgname[p_plgname.length-1] == "leo.src") {
	            //because of two "name" params defined:
	            retItem.Title = "Leo Eng<->Ger";
	            //because of malformed action:
	            retItem.Action = "http://dict.leo.org/";
	            retItem.Desc = cqrMess.GetStringFromName('cqr.err.leo') + retItem.Desc;
		    } else if (p_plgname[p_plgname.length-1] == "leofrn.src"){
	            //because of two name params defined:
	            retItem.Title = "Leo Frn<->Amd";
	            //because of malformed action:
	            retItem.Action = "http://dico.leo.org/";
	            retItem.Desc = cqrMess.GetStringFromName('cqr.err.leo') + retItem.Desc;
		    }
		//EOf leo patch
		retItem.showif = mcSearch[0].showif || "";
		if (retItem.showif) {
		    re = new RegExp(retItem.showif, "ig");
		    retItem.si_compiled = re;
		}
		retItem.sitarget = mcSearch[0].showiftarget || "[:selection]";
		retItem.filepath = filepath;
		retItem.iconpath = getPlugIcon(filepath);
		retItem.Context = true;
	}else{
	  	retItem.eId = "";
	  	retItem.Title = cqrMess.GetStringFromName('cqr.err.parse');
	  	retItem.Method = "GET";
	  	retItem.Desc = filepath;
	  	retItem.Context = false;
	  	retItem.FilePath = filepath;
	}
  return retItem;	
}


function plg_ReadData(filepath){
  var retItem = new ProtoEntry();
  //retItem = new Object;
	filedata = cqReadFile(filepath);
	filedata = filedata.replace(/#.*/ig,"");
	filedata = filedata.replace(/[\n\r\f\t]/ig,"  ");
	SearchTagData = filedata.match(/<search.+?<\/search>/gi);
	mcSearch = plg_GetTags("search", SearchTagData);
	//mcSearch = plg_GetTags("search", filedata);
	if (mcSearch[0]){
		var act = "";
		var amp = "";
		retItem.Title = mcSearch[0].name || cqrMess.GetStringFromName('cqr.err.parse');
		retItem.Action = mcSearch[0].action;
		retItem.Desc = mcSearch[0].description || "";
		//XXX: Leo's malformed plugins special patch:
		    p_plgname = filepath.split(cqrdelim);
		    if (p_plgname[p_plgname.length-1] == "leo.src") {
	            //because of two "name" params defined:
	            retItem.Title = "Leo Eng<->Ger";
	            //because of malformed action:
	            retItem.Action = "http://dict.leo.org/";
	            retItem.Desc = cqrMess.GetStringFromName('cqr.err.leo') + retItem.Desc;
		    } else if (p_plgname[p_plgname.length-1] == "leofrn.src"){
	            //because of two name params defined:
	            retItem.Title = "Leo Frn<->Amd";
	            //because of malformed action:
	            retItem.Action = "http://dico.leo.org/";
	            retItem.Desc = cqrMess.GetStringFromName('cqr.err.leo') + retItem.Desc;
		    }
		//EOf leo patch
		retItem.Method = mcSearch[0].method || "GET";
		retItem.qcharset = mcSearch[0].querycharset || "UTF8";
		retItem.showif = mcSearch[0].showif || "";
		if (retItem.showif) {
		    re = new RegExp(retItem.showif, "ig");
		    retItem.si_compiled = re;
		}
		retItem.sitarget = mcSearch[0].showiftarget || "[:selection]";
		var inp = plg_GetTags("input", SearchTagData);
		//exploreobj(inp);
		for (each in inp){
			//retItem.Inputs[inp[each].priority] = inp[each];
			retItem._StoreInput(inp[each]);
		}
		retItem.eId = "";
		retItem.filepath = filepath;
		retItem.iconpath = getPlugIcon(filepath);
		retItem.Context = true;
	}else{
	  	retItem.eId = "";
	  	retItem.Title = cqrMess.GetStringFromName('cqr.err.parse');
	  	retItem.Method = "GET";
	  	retItem.Desc = filepath;
	  	retItem.Context = false;
	  	retItem.FilePath = filepath;
	}
  return retItem;	
}

function plg_GetTags(tag, str){
	//This extracts all <tag param="val< - > ue"> patterns from str
	var TagsData = [];
	var TagsBuff = [];
	//var cqrTagsRE = new RegExp('(<'+tag+'[ ]+([^>"]+|"[^"]*")+>)', "ig");
	//var cqrTagsRE = new RegExp('(<'+tag+'[ ]+([^>]+|"[^"]*")+>)', "ig");
	var cqrTagsRE = new RegExp('<'+tag+'\\s.+?>(?=[^"<]+?<|$)', "ig");
	while (TagsBuff!=null){
	  TagsBuff = cqrTagsRE.exec(str);
	  if (TagsBuff!=null){
			TagsData[TagsData.length]=plg_TagParams(TagsBuff[0]);
			TagsData[TagsData.length-1].priority = cqrTagsRE.lastIndex;
	  }
	}
return TagsData;
}

function plg_TagParams(tag){
  var Params = new Object;
  var ParamsBuff = "  ";
  var ParamsData = [];
  //To correct Mycroft's "user" in <input>.
  tag = String(tag).replace(/\s+?user(?=\s*[\/>])/i, ' value="[:selection]"');
  Params["value"]= cqrMess.GetStringFromName('cqr.err.parse');
  ParamsBuff = cqrParamsRE.exec(tag);
  while (ParamsBuff!=null){
		if (ParamsBuff!=null){
			ParamsArr = String(ParamsBuff[0]).split(/=\s*"/);
			ParamsArr[1] = ParamsArr[1].replace(/^\s+/, "");
			Params[String(ParamsArr[0].replace(/\s+/,"")).toLowerCase()] = ParamsArr[1].replace(/"\s*/, "");
			ParamsBuff = cqrParamsRE.exec(tag);
		}
	}
  //for not parenthesized params (i.e. param=value)
//  ParamsBuff = "  ";
//  
//  while (ParamsBuff){
//		ParamsBuff = String(tag).match(/\w+?\s*?=\s*?\w+?(?=[\s\/>])/i);
//		if (ParamsBuff){
//			ParamsArr = String(ParamsBuff).split(/=/);
//			ParamsArr[1] = ParamsArr[1].replace(/^\s+/, "");
//			Params[String(ParamsArr[0].replace(/\s+/,"")).toLowerCase()] = ParamsArr[1].replace(/\s+$/, "");
//			tag = String(tag).replace(ParamsBuff, "");
//		}
//	}
return Params;
}

function rdir(dirname){
try{
  var arr = [];
  var dir = Components.classes["@mozilla.org/file/local;1"].
             createInstance(Components.interfaces.nsILocalFile);
  dir.initWithPath(dirname);
  if (dir.isDirectory()) {
      items = dir.directoryEntries;
  } else {
      cqerr(null, "Error reading directory:\n" + dirname);
      return arr;
  }

  items.QueryInterface(Components.interfaces.nsISimpleEnumerator);
  while (items.hasMoreElements()) {
    var i = items.getNext();
    i.QueryInterface(Components.interfaces.nsIFile);
    if (i.isDirectory()){
    }else{
      var fn = i.leafName;
      var fx = fn.substr(fn.length - 4, fn.length).toLowerCase();
      if ((fx == ".cqr")||(fx == ".src")) {
        arr[i.path] = i.lastModifiedTime;
      }
    }
  }
return arr;
}catch(err){return arr}
}

function cqReadFile(filename) {
    var MODE_RDONLY = 0x01;
    var PERM_IRUSR = 00400;
    
    try {
        var file = Components.classes["@mozilla.org/file/local;1"].
                   createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(filename);
        if (file.exists() && file.isReadable()) {
            var is = Components.classes["@mozilla.org/network/file-input-stream;1"].
                     createInstance(Components.interfaces.nsIFileInputStream);
            is.init(file, MODE_RDONLY, PERM_IRUSR, 0);
            var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].
                createInstance(Components.interfaces.nsIScriptableInputStream);
            sis.init(is);
            var data = sis.read(sis.available());
            sis.close();
            is.close();
            return data;
        }
        else {
            cqerr(null, "File" + filename + "read error in cqReadFile\n");
            return null;
        }
    }
    catch (er) {
        cqerr(er, "File" + filename + "read error in cqReadFile\n");
    }
    return null;
}

function GetMycroftDir(){
	var gDirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	var gChromeDir      = gDirServiceProp.get("AChrom",Components.interfaces.nsIFile);
	patharr = gChromeDir.path.split(cqrdelim);
	patharr[patharr.length-1]="searchplugins";
	return patharr.join(cqrdelim);
}

function srcupdated() {
  var rval = false;
  var lastcnt = 0;
  var curcnt = 0;
  
  for (each in lastDirState) { lastcnt+=1 }
  for (each in curDirState) { curcnt+=1 }

  if (lastcnt != curcnt) {
    rval = true;
  } else {
    for (each in lastDirState) {
      if (curDirState[each] != lastDirState[each]) { 
        rval = true;
        break;
      }
    }
  }
  curDirState = lastDirState;
  //rval = true;
  return rval;
}

function prfs_LoadMain(){
  cqrPlugsDir = prfs_ReadItem("Main.PlugsDir");
  cqrUseHotMenu = prfs_ReadItem("Main.UseHotMenu");
  cqrHTTPIcon = prfs_ReadItem("Main.HTTPIcon");
  cqrOpenRes = prfs_ReadItem("Main.OpenResults");
  cqrHideFromTools = prfs_ReadItem("Main.HideFromTools");
  if (!cqrPlugsDir) cqrPlugsDir = GetMycroftDir();
  if (cqrOpenRes == "") {cqrOpenRes = "tab_bg"};
}

function prfs_SaveMain(){
  cqrPlugsDir = document.getElementById("prfs_plugsdir").value;
  cqrUseHotMenu = document.getElementById("enhotmenu").checked;
  cqrHTTPIcon = document.getElementById("HTTPIcon").checked;
  cqrOpenRes = document.getElementById("open_res").selectedItem.id;
  cqrHideFromTools = document.getElementById('hidefromtools').checked;
  cqrPrefs.setCharPref("Main.PlugsDir", cqrPlugsDir);
  cqrPrefs.setBoolPref("Main.UseHotMenu", cqrUseHotMenu);
  cqrPrefs.setBoolPref("Main.HTTPIcon", cqrHTTPIcon);
  cqrPrefs.setCharPref("Main.OpenResults", cqrOpenRes);
  cqrPrefs.setBoolPref("Main.HideFromTools", cqrHideFromTools);
}

function prfs_LoadEntries(){
try{
  //EntryHash._Clear();
  var entries = new Object();
  //var entry = new ProtoEntry();
  var prfs = cqrPrefs.getChildList("Entries.", {value: 0});
    for (p in prfs){
      tmp = prfs[p].split(".");
      entries[tmp[1]] = "";
    }
  for (it in entries){
    entry = new ProtoEntry();
    entry.eId       = prfs_ReadItem("Entries."+it+".eId");
    entry.Title     = prfs_ReadItem("Entries."+it+".Title");
    entry.Method    = prfs_ReadItem("Entries."+it+".Method");
    entry.Desc      = prfs_ReadItem("Entries."+it+".Desc");
    entry.Context   = prfs_ReadItem("Entries."+it+".Context");
    entry.blocked    = prfs_ReadItem("Entries."+EntryId+".blocked");
    entry.showif    = prfs_ReadItem("Entries."+it+".showif");
    entry.filepath  = prfs_ReadItem("Entries."+it+".filepath");
    EntryHash._AddEntryObj(entry, entry.eId);
  }
}catch(er){cqerr(er, "prfs_LoadEntries sub")}
}

function prfs_LoadEntry(EntryId){
try{
  if (cqrPrefs.prefHasUserValue("Entries."+EntryId+".Title")) {
    entry = new ProtoEntry();
    entry.Context   = prfs_ReadItem("Entries."+EntryId+".Context");
    //entry.showif    = prfs_ReadItem("Entries."+EntryId+".showif");
    entry.blocked    = prfs_ReadItem("Entries."+EntryId+".blocked");
    return entry;
  } else {return ""}
}catch(er){cqerr(er, "prfs_LoadEntry sub")}
}

function prfs_UpdateEntries(){
  entries = EntryHash._Items();
  for (each in entries) {
    id = entries[each].eId;
    var EntryPrefs = prfs_LoadEntry(id);
    if (EntryPrefs) {
      EntryHash[id].Context = EntryPrefs.Context;
      EntryHash[id].blocked = EntryPrefs.blocked;
    } else {
      EntryHash[id].blocked = false;
      EntryHash[id].Context = true;
    }
  }
}

function prfs_SaveEntries(){
try{
  cqrPrefs.deleteBranch("Entries.");
  var entries = EntryHash._Items();
  for (e in entries){
    if ((!entries[e].Context) || (entries[e].blocked)){
      cqrPrefs.setCharPref("Entries."+entries[e].eId+".eId", entries[e].eId);
      cqrPrefs.setCharPref("Entries."+entries[e].eId+".Title", entries[e].Title);
      //cqrPrefs.setCharPref("Entries."+entries[e].eId+".Method", entries[e].Method);
      //cqrPrefs.setCharPref("Entries."+entries[e].eId+".Desc", entries[e].Desc);
      cqrPrefs.setCharPref("Entries."+entries[e].eId+".filepath", entries[e].filepath);
      cqrPrefs.setBoolPref("Entries."+entries[e].eId+".Context", entries[e].Context);
      cqrPrefs.setBoolPref("Entries."+entries[e].eId+".blocked", entries[e].blocked);
      //cqrPrefs.setCharPref("Entries."+entries[e].eId+".showif", entries[e].showif);
    }
	}
}catch(er){cqerr(er, "prfs_SaveEntries sub")}
}

function prfs_ReadItem(name){
	if (cqrPrefs.prefHasUserValue(name)) {
  	var type = cqrPrefs.getPrefType(name);
    if (type & 128) {
      return cqrPrefs.getBoolPref(name);
    } else if (type & 32) {
			return cqrPrefs.getCharPref(name);
    }	else {
			return "";
		}
	} else {
	    //Good features must be turned on by default :))
	    if ((name == "Main.HTTPIcon") || (name == "Main.LoadTabsInBg")){
	        return true;
	    } else {
	        return "";
	    }
	}
}

function getPlugIcon(plugpath){
    var icon_gif = plugpath.substr(0, plugpath.length -4) + ".gif";
    var icon_png = plugpath.substr(0, plugpath.length -4) + ".png";
    
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    
    file.initWithPath(icon_gif);
    if (file.exists()) {
        return icon_gif;
    } else {
        file.initWithPath(icon_png);
        if (file.exists()) {
            return icon_png;
        } else {
            return "";
        }
    }
}

function exploreobj(obj){
  for (each in obj) {
    show("NODE ::: " + each);
    a = obj[each];
      for (i  in  a){
        show(i + " >>> " + a[i]);
      }
    }
}

function cqrAbsURI(base, url) 
{
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                .getService(Components.interfaces.nsIIOService);
  var baseURI  = ioService.newURI(base, null, null);
  return ioService.newURI(baseURI.resolve(url), null, null).spec;
}

function getFNameFromURI(uri){
    var arr = uri.split("/");
    return arr[arr.length - 1];
    }

function url2host(url){
    var re = new RegExp("^http://([^/]*)","ig");
    retmp = re.exec(url);
    if (retmp) {
        return retmp[0];
    } else {
        return "";
    }
}
